<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Document</title>

    <link
      href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.1/dist/css/bootstrap.min.css"
      rel="stylesheet"
      integrity="sha384-4bw+/aepP/YC94hEpVNVgiZdgIC5+VKNBQNGCHeKRQN+PtmoHDEXuppvnDJzQIu9"
      crossorigin="anonymous"
    />
    <script
      src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.1/dist/js/bootstrap.bundle.min.js"
      integrity="sha384-HwwvtgBNo3bZJJLYd8oVXjrBZt8cqVSpeBNS5n7C8IVInixGAoxmnlMuBnhbgrkm"
      crossorigin="anonymous"
    ></script>

    <link rel="preconnect" href="https://fonts.googleapis.com" />
    <link rel="preconnect" href="https://fonts.gstatic.com" crossorigin />
    <link
      href="https://fonts.googleapis.com/css2?family=Roboto&family=Scope+One&display=swap"
      rel="stylesheet"
    />

    <style>
      .bg-image {
        background-image: url("images/Rectangle10.png");
        width: 100vw;
        height: 69vw;
        background-size: cover;
        display: flex;
        justify-content: center;
        align-items: center;
      }

      .bg-image-content {
        background-image: url("images/Rectangle1-fix.png");
        width: 74%;
        height: 79%;
        background-size: cover;
      }

      .content {
        border: 8px solid rgba(229, 229, 229, 0.54);
        background: #e5e5e5;
        padding: 4rem 3rem 4rem 3rem;
      }

      .tittle {
        color: #303234;
        text-align: center;
        font-family: Scope One;
        font-size: 36px;
        font-style: normal;
        font-weight: 400;
        line-height: normal;
        margin-bottom: 3rem;
      }

      button {
        background: rgba(251, 252, 253, 0.65);
        margin-top: 2.5rem;
        padding: 14px 30px 14px 30px;
        border: 0px;
        color: #000;
        text-align: center;
        font-family: Roboto;
        font-size: 24px;
        font-style: normal;
        font-weight: 700;
        line-height: normal;
      }

      .carveli {
        background-image: url("images/CARVELI.png");
        width: 18rem;
        height: 4rem;
        background-size: 18rem 4rem;
        margin: 5rem auto 0rem auto;
      }
    </style>
  </head>
  <body>
    <div class="bg-image">
      <div class="row bg-image-content">
        <div class="col-md-6 text-center content">
          <div class="tittle">Contact Us</div>
          <form action="" id="submit-form">
            <div class="form-group">
              <input
                id="input-name"
                type="text"
                class="form-control"
                placeholder="Name"
              />
            </div>

            <div
              class="form-group"
              style="margin-top: 2rem; margin-bottom: 2rem;"
            >
              <input
                id="input-email"
                type="text"
                class="form-control"
                placeholder="Email"
              />
            </div>

            <div class="form-group">
              <textarea
                id="text-area-message"
                class="form-control"
                placeholder="Write something..."
              ></textarea>
            </div>

            <button type="submit">Submit</button>
          </form>
        </div>

        <div class="col-md-6">
          <div class="carveli"></div>
        </div>
      </div>
    </div>
  </body>

  <script>
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_CREATED = 201;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL_CONTACTS =
      "https://62458c222cfed18817229118.mockapi.io/contacts";
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    var submitForm = document.getElementById("submit-form");
    submitForm.addEventListener("submit", (e) => {
      // Sử dụng preventDefault để loại bỏ hành động submit mặc định của form
      e.preventDefault();
      // Bước 0: Khởi tạo đối tượng thu thập
      var vObject = {
        name: "",
        email: "",
        mess: "",
      };
      // Bước 1: thu thập dữ liệu
      getDataFromInput(vObject);
      // Bước 2: Kiểm tra dữ liệu thu thập
      var vCheck = validateData(vObject);
      // Bước 3: gọi API xử lý
      if (vCheck) {
        // create a request
        var vXmlHttpCreateContact = new XMLHttpRequest();
        processAPI(vXmlHttpCreateContact, vObject);
        vXmlHttpCreateContact.onreadystatechange = function () {
          if (
            this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK &&
            this.status == gREQUEST_STATUS_CREATED
          ) {
            var vSubmitRespond = vXmlHttpCreateContact.responseText;
            //B4: hiển thị dữ liệu
            hienThiDuLieu(vSubmitRespond);
          }
        };
      }
    });
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // Hàm thu thập dữ liệu
    function getDataFromInput(paramObject) {
      "use strict";
      var vNameInput = document.getElementById("input-name");
      var vEmailInput = document.getElementById("input-email");
      var vMessTextarea = document.getElementById("text-area-message");

      paramObject.name = vNameInput.value;
      paramObject.email = vEmailInput.value;
      paramObject.mess = vMessTextarea.value;
    }

    // Hàm kiểm tra dữ liệu thu thập
    // Input là đối tượng dữ liệu cần kiểm tra
    // Output là kết quả true / false
    function validateData(paramObject) {
      "use strict";
      var vName = paramObject.name.trim(); // Chuẩn hóa dữ liệu
      var vEmail = paramObject.email.trim();
      var vMess = paramObject.mess.trim();

      if (vName == "") {
        alert("Name is empty!");
        return false;
      }

      if (vEmail == "") {
        alert("Email is empty!");
        return false;
      }
      if (validateEmail(vEmail) == false) {
        alert("Email is invalid!");
        return false;
      }

      return true;
    }

    // Hàm kiểm tra email
    // Input là email cần kiểm tra
    // Output là true / false
    function validateEmail(mail) {
      if (/^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,3})+$/.test(mail)) {
        return true;
      }
      return false;
    }

    // Hàm xử lý ajax API create contact
    // Input là đối tượng Request và đối tượng dữ liệu
    function processAPI(paramRequest, paramObject) {
      "use strict";
      var vData = JSON.stringify({ paramObject });

      paramRequest.open("POST", gBASE_URL_CONTACTS, true);
      paramRequest.send(vData);
    }

    //hàm hiển thị dữ liệu
    function hienThiDuLieu(paramRespond) {
      console.log(paramRespond);
    }
  </script>
</html>
